/*
 * $Id: kl_net_interface.h,v 1.4 2001/06/20 01:35:43 laik Exp $
 *
 * Copyright (C) 1993 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __NET_INTERFACE_H__
#define __NET_INTERFACE_H__

#include <net/if.h>
#include <netinet/in.h>

#include "kl_exception.h"

#define	NET_INTERFACE_HADDR	 8 /* allow for 64-bit EUI-64 in future */

typedef struct KLNetInterfaceInfo {
    char name[IFNAMSIZ];	   /* interface name, null terminated */
    u_char haddr[NET_INTERFACE_HADDR]; /* hardware address */
    u_short hlen;		   /* #bytes in hardware address: 0, 6, 8 */
    long flags;		           /* IFF_xxx constants from <net/if.h> */
    long myflags;	           /* our own NET_INTERFACE_FLAGS_xxx flags */
    struct sockaddr *addr;	   /* primary address */
    struct sockaddr *brdaddr;      /* broadcast address */
    struct sockaddr *dstaddr;      /* destination address */
    struct KLNetInterfaceInfo *next; /* next of these structures */
} KLNetInterfaceInfo;

#define	NET_INTERFACE_FLAGS_ALIAS	1  /* addr is an alias */


KLNetInterfaceInfo *
KLNetInterfaceGetInfo(int family, int doaliases);

void
KLNetInterfaceFreeInfo(KLNetInterfaceInfo *begin);

KLException *
KLNetInterfaceSearchRoute(
    struct sockaddr_in *dest, KLNetInterfaceInfo *interfaces, 
    KLNetInterfaceInfo **result);

void
KLNetInterfaceTest(void);

#endif
