/*
 * $Id: kl_network_protocol_ipv4.h,v 1.3 2000/10/06 00:08:19 laik Exp $
 *
 * This file contains interfaces and data structures for the flow module.
 *
 * Copyright (C) 1998 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __NETWORK_PROTOCOL_IPV4_H__
#define __NETWORK_PROTOCOL_IPV4_H__

#include <netinet/ip.h>
#include "kl_network_protocol.h"

typedef struct KLNetworkProtocolIPv4PacketDef {
    struct ip ip;
    void *client_data;
} KLNetworkProtocolIPv4PacketDef;

unsigned short
KLNetworkProtocolIPv4Checksum(const u_int8_t *buf, int len, int start);

unsigned short
KLNetworkProtocolIPv4TransportChecksum(
    const struct ip *ip, const u_int8_t *payload, unsigned int buf_len);

KLNetworkProtocol *
KLNetworkProtocolIPv4New(void);

#endif
