/*
 * $Id: kl_set.h,v 1.1 2001/03/30 22:53:33 laik Exp $
 *
 * This file contains interfaces for routines which manage unordered
 * sets of integers.
 *
 * Copyright (C) 2001 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SET_H__
#define __SET_H__

#include "kl_util.h"

struct KLSet;
typedef struct KLSet KLSet;

typedef void (*KLSetFreeFun)(void *client_data, void *item);

KLSet *
KLSetNew(
    unsigned int size, unsigned int have_items, 
    KLSetFreeFun free_fun, void *client_data);

void
KLSetFree(KLSet *set);

void
KLSetAddItem(KLSet *set, unsigned int index, void *item);

void
KLSetRemoveItem(KLSet *set, unsigned int item, unsigned int free_item);

int
KLSetGetItem(KLSet *set, unsigned int item, void **item_p);

#endif
