/*
 * $Id: kl_socket.h,v 1.4 2000/11/22 23:45:57 laik Exp $
 *
 * Copyright (C) 1993 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SOCKET_H__
#define __SOCKET_H__

#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "kl_event.h"

#ifndef SHUT_RDWR
#define SHUT_RDWR 2
#endif

/* */
typedef KLException * (*KLSocketConnectFinishedFun)(
    void *client_data, int error);

extern KLExceptionClass KLSocketECGetAddrInfo;

int
KLSocketAccept(int listen_socket, struct sockaddr_in *client_addr,
	     socklen_t *client_addr_len);

int
KLSocketBind(int s, const char *local_service);

KLException *
KLSocketTCPConnect(
    const char *host, const char *service, KLEventManager *manager,
    KLSocketConnectFinishedFun connect_finished_fun,
    void *client_data, int *non_blocking, int *connect_socket_p);

int
KLSocketTCPSend(int s, char *buffer, int buf_len, int non_blocking);

int
KLSocketTCPRecv(int s, char *buf, int buf_len, int non_blocking);

KLException *
KLSocketGetHostService(
    const char *host, const char *service, int flags, int family,
    int socktype, struct sockaddr *sock_addr, int *sock_addr_len);

KLException *
KLSocketIsLocalHost(const char *host, int *is_local_host);

void
KLSocketTest(void);

#endif
