/*
 * $Id: kl_statistics.h,v 1.5 2001/01/10 23:48:01 laik Exp $
 *
 * Copyright (C) 1993 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __STATISTICS_H__
#define __STATISTICS_H__

#include "kl_exception.h"
#include "kl_statistics_metric.h"
#include "kl_statistics_mapping.h"
#include "kl_table.h"

struct KLStatisticsSet;
typedef struct KLStatisticsSet KLStatisticsSet;

typedef struct KLStatisticsSetDef {
    unsigned int dimensions;               /* # of columns in table. */
    KLStatisticsSet *source_set;           /* Set to get data from. */
    int bootstrap;                         /* Whether to bootstrap or not. */
    const int *permutation;                /* Maps from this set to source. */
    KLStatisticsMapping *mapping;          /* How the mapping is set up. */
    KLStatisticsMetricType **metric_types; /* Metrics to compute. */
} KLStatisticsSetDef;

KLStatisticsSet *
KLStatisticsSetNew(KLStatisticsSetDef *def);

void
KLStatisticsSetFree(KLStatisticsSet *set);

KLTable *
KLStatisticsSetGetTable(KLStatisticsSet *set);

void
KLStatisticsSetBootstrap(
    KLStatisticsSet *set, unsigned int resample_size, unsigned int iterations);

void
KLStatisticsSetPrint(KLStatisticsSet *set);

#ifdef TEST

void
KLStatisticsTest(void);

#endif

#endif
