/*
 * $Id: kl_statistics_regression.h,v 1.3 2000/10/06 00:08:19 laik Exp $
 *
 * Copyright (C) 2000 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __STATISTICS_REGRESSION_H__
#define __STATISTICS_REGRESSION_H__

#include "kl_statistics.h"

typedef struct KLStatisticsRegressionDef {
    KLStatisticsSet *model_set;          /* Set that has the model data. */
    unsigned int dep_var_index;        /* Dependent variable in model set. */
} KLStatisticsRegressionDef;

typedef struct KLStatisticsRegressionSampleStatistics {
    double mean_square_error;
    double r_square;
    double adj_r_square;
} KLStatisticsRegressionSampleStatistics;


struct KLStatisticsRegression;
typedef struct KLStatisticsRegression KLStatisticsRegression;

KLStatisticsRegression *
KLStatisticsRegressionNew(KLStatisticsRegressionDef *def);

void
KLStatisticsRegressionFree(KLStatisticsRegression *sr);

void
KLStatisticsRegressionCompute(
    KLStatisticsRegression *sr, double *coefficients, double *standard_errors,
    KLStatisticsRegressionSampleStatistics *srss);

#ifdef TEST

void
KLStatisticsRegressionTest(void);

#endif

#endif
